// -*- C++ -*-
//
// This file is part of the Coriolis Software.
// Copyright (c) UPMC 2009-2018, All Rights Reserved
//
// +-----------------------------------------------------------------+ 
// |                   C O R I O L I S                               |
// |           H u r r i c a n e   A n a l o g                       |
// |                                                                 |
// |  Authors     :            C. Alexandre, J.-M. Caba              |
// |  E-mail      :            Jean-Paul.Chaput@lip6.fr              |
// | =============================================================== |
// |  C++ Module  :  "./TransistorFamilyNames.cpp"                   |
// +-----------------------------------------------------------------+

#include "hurricane/analog/TransistorFamilyNames.h"

namespace Analog {

  
  const char* TransistorFamilyNames::PMOSTransistorBU          ("PMOS Transistor Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSTransistorBC          ("PMOS Transistor Bulk Connected");
  const char* TransistorFamilyNames::NMOSTransistorBU          ("NMOS Transistor Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSTransistorBC          ("NMOS Transistor Bulk Connected");
  const char* TransistorFamilyNames::PMOSDifferentialPairBU    ("PMOS Differential Pair Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSDifferentialPairBC    ("PMOS Differential Pair Bulk Connected");
  const char* TransistorFamilyNames::NMOSDifferentialPairBU    ("NMOS Differential Pair Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSDifferentialPairBC    ("NMOS Differential Pair Bulk Connected");
  const char* TransistorFamilyNames::PMOSSimpleCurrentMirrorBU ("PMOS Simple Current Mirror Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSSimpleCurrentMirrorBC ("PMOS Simple Current Mirror Bulk Connected");
  const char* TransistorFamilyNames::NMOSSimpleCurrentMirrorBU ("NMOS Simple Current Mirror Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSSimpleCurrentMirrorBC ("NMOS Simple Current Mirror Bulk Connected");
  const char* TransistorFamilyNames::PMOSLevelShifterBU        ("PMOS Level Shifter Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSLevelShifterBC        ("PMOS Level Shifter Bulk Connected");
  const char* TransistorFamilyNames::NMOSLevelShifterBU        ("NMOS Level Shifter Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSLevelShifterBC        ("NMOS Level Shifter Bulk Connected");
  const char* TransistorFamilyNames::PMOSCrossCoupledPairBU    ("PMOS Cross Coupled Pair Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSCrossCoupledPairBC    ("PMOS Cross Coupled Pair Bulk Connected");
  const char* TransistorFamilyNames::NMOSCrossCoupledPairBU    ("NMOS Cross Coupled Pair Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSCrossCoupledPairBC    ("NMOS Cross Coupled Pair Bulk Connected");
  const char* TransistorFamilyNames::PMOSCommonSourcePairBU    ("PMOS Common Source Pair Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSCommonSourcePairBC    ("PMOS Common Source Pair Bulk Connected");
  const char* TransistorFamilyNames::NMOSCommonSourcePairBU    ("NMOS Common Source Pair Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSCommonSourcePairBC    ("NMOS Common Source Pair Bulk Connected");
  const char* TransistorFamilyNames::NMOSCommonGatePairBC      ("NMOS Common Gate Pair Bulk Connected");
  const char* TransistorFamilyNames::PMOSCommonGatePairBU      ("PMOS Common Gate Pair Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSCommonGatePairBC      ("PMOS Common Gate Pair Bulk Connected");
  const char* TransistorFamilyNames::NMOSCommonGatePairBU      ("NMOS Common Gate Pair Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSCommonDrainBC         ("NMOS Common Drain Bulk Connected");
  const char* TransistorFamilyNames::PMOSCommonDrainBU         ("PMOS Common Drain Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSCommonDrainBC         ("PMOS Common Drain Bulk Connected");
  const char* TransistorFamilyNames::NMOSCommonDrainBU         ("NMOS Common Drain Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSCascodeBU             ("PMOS Cascode Bulk Unconnected");
  const char* TransistorFamilyNames::PMOSCascodeBC             ("PMOS Cascode Bulk Connected");
  const char* TransistorFamilyNames::NMOSCascodeBU             ("NMOS Cascode Bulk Unconnected");
  const char* TransistorFamilyNames::NMOSCascodeBC             ("NMOS Cascode Bulk Connected");


}  // Analog namespace.
